open Langage

module type Kernel_type =
sig
  val run : obj -> unit
end

module Kernel : Kernel_type =
struct
  let int_of_obj = function
    | Entier i -> i
    | _ -> failwith "Couldn't evaluate object as an integer !"

  let link name x env = (Chaine(name), x)::env

  let push x env = link "" x env

  let rec pop = function
    | (Chaine "", x)::s -> x, s
    | h::s -> let a, b = pop s in a, (h::b)
    | [] -> failwith "Failed to pop !"

  let rec make_cont code env cont =
    let nil_cont = (fun _ _ -> ()) in
      match code with
	| Entier i ->
	    (
	      cont (push (Entier i) env) nil_cont
	    )
	| Op_add(a, b) ->
	    make_cont a env
	    (
	      fun e c -> make_cont b e
		(
		  fun e' c' ->
		    (* let a1, env1 = pop env in
		    let a2, env2 = pop env1 in *)
		      c' (*push (Entier ((int_of_obj a1) + (int_of_obj a2))) e'*) e' cont
		)
	    )
	| _ -> failwith "Unknown language object !"
	  
  let run code =
    (* TODO : should do the display in main ? *)
    make_cont code [] (fun env cont -> Display.print_result (let a, b = pop env in a))
end
