%{
	open Langage;;
%}
 /* File parser.mly */

%token <int> INTEGER
%token <string> ID
%token LPAR RPAR
%token NIL
%token IS_CONS
%token CONS
%token CAR
%token CDR
%token <string> CWR
%token EQ_INT
%token QUOTE
%token EVAL
%token IF
%token SET
%token SETQ
%token LET
%token LAMBDA
%token BEGIN
%token PRINT
%token PLUS
%token MINUS
%token EOF
%start objet 
%type <Langage.obj> objet

%%

objet:
   | INTEGER {Entier $1}
   | ID      {Chaine $1}
   | NIL     {Nil}
   | LPAR op_or_list RPAR {$2}

op_or_list:
   | IS_CONS objet {Op_is_cons($2)}
   | CONS objet objet {Op_cons($2,$3)}
   | CAR objet {Op_car($2)}
   | CDR objet {Op_cdr($2)}
   | CWR objet {Op_cwr($1,$2)}
   | EQ_INT objet objet {Op_eq_int($2,$3)}
   | QUOTE objet {Op_quote($2)}
   | EVAL objet {Op_eval($2)}
   | IF objet objet objet {Op_if($2,$3,$4)}
   | SET objet objet {Op_set($2,$3)}
   | SETQ objet objet  {Op_setq($2,$3)}
   | LET objet objet {Op_let($2,$3)}
   | LAMBDA objet objet {Op_lambda($2,$3)}
   | BEGIN objlist{Op_begin_comp($2)}
   | PRINT objet {Op_print($2)}
   | PLUS objet objet {Op_add ($2,$3)}
   | MINUS objet objet {Op_substract ($2,$3)}

objlist:
   | objet objlist {Compose ($1,$2)}
   | /* */ {Nil}
