%{
	open Language;;
%}
 /* File parser.mly */

%token <int> INTEGER
%token <string> ID
%token LPAR RPAR
%token NIL
%token IS_CONS
%token CONS
%token CAR
%token CDR
%token <string> CWR
%token EQ_INT
%token QUOTE
%token AQUOTE
%token EVAL
%token IF
%token SET
%token SETQ
%token LET
%token CALLCC
%token LAMBDA
%token BEGIN
%token PRINT
%token PLUS
%token MINUS
%token TIMES
%token DIVIDES
%token MODULE
%token DOT
%token STOP
%start parse
%type <Language.obj> parse

%%

parse: objet STOP {$1}

objet:
   | INTEGER {Entier $1}
   | ID      {Chaine $1}
   | NIL     {Liste []}
   | LPAR objlist RPAR {Liste $2}
   | IS_CONS {Op_is_cons}
   | CONS {Op_cons}
   | CAR {Op_car}
   | CDR {Op_cdr}
   | CWR {Op_cwr($1)}
   | EQ_INT {Op_eq_int}
   | QUOTE {Op_quote}
   | AQUOTE objet {Liste(Op_quote::[$2])}
   | EVAL {Op_eval}
   | IF {Op_if}
   | SET {Op_set}
   | SETQ {Op_setq}
   | LET {Op_let}
   | LAMBDA {Op_lambda}
   | BEGIN {Op_begin}
   | PRINT {Op_print}
   | PLUS {Op_add}
   | MINUS {Op_sub}
   | TIMES {Op_mult}
   | DIVIDES {Op_div}
   | CALLCC {Op_callcc}
   | MODULE {Op_module}
   | DOT objet {Liste(Op_quote::[Liste(Op_quote::[$2])])}

objlist:
   | objet objlist {$1::$2}
   | /* */ {[]}
